//
//  JelApp.swift
//  Jel
//
//  Created by zerocool on 12/11/23.
//

import SwiftUI

@main
struct JelApp: App {
  let datamodelController = DatamodelController.shared
  let authStateController = AuthStateController.shared
  
  let jellyfinClientController = JellyfinClientController(authHeaders: AuthHeaders(
    Client: "Jel",
    Device: UIDevice.current.systemName,
    DeviceId: UIDevice.current.identifierForVendor!.uuidString,
    Version: Bundle.main.object(forInfoDictionaryKey: "CFBundleShortVersionString") as? String ?? "0.0.0",
    Token: ""))
  
  var body: some Scene {
    WindowGroup {
      ContentView(authState: authStateController)
        .environment(\.managedObjectContext,
                      datamodelController.container.viewContext)
        .environmentObject(jellyfinClientController)
        .task {
          authStateController.load()
          if authStateController.serverUrl != nil {
            jellyfinClientController.setUrl(url: authStateController.serverUrl!)
          }
        }
    }
  }
}
